// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/clients -i Clients -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/clients"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements clients.Clients that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   clients.Clients
}

// AccessLoggingMiddleware instruments an implementation of the clients.Clients with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next clients.Clients) clients.Clients {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, client *clients.Client) (created *clients.Client, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("client", client),
	)

	created, err = m.next.Create(ctx, client)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, spaceId string, id string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	err = m.next.Delete(ctx, spaceId, id)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Enable(ctx context.Context, spaceId string, id string, enable bool) (err error) {
	begin := time.Now()

	m.logger.Debug("Enable.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
		zap.Reflect("enable", enable),
	)

	err = m.next.Enable(ctx, spaceId, id, enable)

	m.logger.Debug("Enable.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, id string) (client *clients.Client, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	client, err = m.next.Get(ctx, spaceId, id)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("client", client),
		zap.Error(err),
	)

	return client, err
}

func (m *accessLoggingMiddleware) GetBy(ctx context.Context, spaceId string, params *clients.GetByParams) (client *clients.Client, err error) {
	begin := time.Now()

	m.logger.Debug("GetBy.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("params", params),
	)

	client, err = m.next.GetBy(ctx, spaceId, params)

	m.logger.Debug("GetBy.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("client", client),
		zap.Error(err),
	)

	return client, err
}

func (m *accessLoggingMiddleware) List(ctx context.Context, spaceId string) (clients []*clients.Client, err error) {
	begin := time.Now()

	m.logger.Debug("List.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
	)

	clients, err = m.next.List(ctx, spaceId)

	m.logger.Debug("List.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("clients", clients),
		zap.Error(err),
	)

	return clients, err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, client *clients.Client) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("client", client),
	)

	err = m.next.Update(ctx, client)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
