package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/members/observer"
	"git.perx.ru/perxis/perxis-go/pkg/members/observer/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/members"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc observer.Observer, opts ...grpckit.ServerOption) pb.ObserverServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		OnCollaboratorSetEndpoint: grpcerr.ServerMiddleware(eps.OnCollaboratorSetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
