package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/roles"
	"git.perx.ru/perxis/perxis-go/pkg/roles/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/roles"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc roles.Roles, opts ...grpckit.ServerOption) pb.RolesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint: grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint: grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		GetEndpoint:    grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListEndpoint:   grpcerr.ServerMiddleware(eps.ListEndpoint),
		UpdateEndpoint: grpcerr.ServerMiddleware(eps.UpdateEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
